import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The home of ants.
 * 
 * @author AntMind - Team2 
 * @version 11.3.2019
 */
public class Anthill extends Actor
{
    private int ants = 10;
    private int food = 0;
    private boolean firstSpawn=true;
    private CounterF foodCounter;
    private CounterA antCounter;
    /**
     * The base of ants. It stores food and spawns new ants.
     */
    public void act() 
    {
        if(firstSpawn){firstSpawn();} //Release 10 ants in the begining.
        spawn(); //If there is enough food, spawn a new ant.
        counter(); //Counts number of ants and food.
        
    }
    public void spawn()
    {
        if(food>ants){
            getWorld().addObject(new Ant(this), getX(), getY());
            ants++;
            food -= (ants*0.5);
        }
        
    }
    public int getCounterF(int a) //Enables other actors to change the counter.
    {
        food += a;
        return food;
    }
    public int getAnts(int b)//Enables other actors to change the counter.
    {
        ants += b;
        return ants;
    }
    public void firstSpawn()
    {
        for(int x=ants;x>0;x--){
            getWorld().addObject(new Ant(this), getX(), getY());
        }
        firstSpawn=false;
    }
    public void counter()
    {
        if(foodCounter == null) 
        {
            foodCounter = new CounterF(this);
            int x = getX();
            int y = getY() + getImage().getWidth()/2;

            getWorld().addObject(foodCounter, x, y);
        }
        if(antCounter == null) 
        {
            antCounter = new CounterA(this);
            int x = getX();
            int y = getY() - getImage().getWidth()/2;

            getWorld().addObject(antCounter, x, y);
        }  
    }

}
