import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The arena where are the ants.
 * 
 * @author AntMind - Team2
 * @version 22.5.2019
 */
public class Arena extends World
{

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public Arena()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 400, 1);
        populateStatic();
        setPaintOrder(Player.class,Victory.class,Ant.class,Predator.class,CounterA.class,CounterF.class,Anthill.class,HoneyDrop.class,Pheromone.class);
        
    }

    public void populateStatic(){ 
        //Scientifical scenarion with only one anthill and no animals apart from ants.
        removeObjects(getObjects(null)); // Removes all objects
        addObject(new Anthill(), 200, 100);
        addObject(new HoneyDrop(25), 350, 365);
        addObject(new HoneyDrop(50), 400, 150);
        addObject(new HoneyDrop(75), 120, 225);
        addObject(new HoneyDrop(125), 750, 150);
        addObject(new HoneyDrop(150), 550, 20);
        addObject (new Feeder(), 0, 0);
    }

    public void populateDynamic(){
        //Scenario with Predator and random layout and amount of Anthills and HoneyDrops.
        removeObjects(getObjects(null)); // Removes all objects
        int anthills = Greenfoot.getRandomNumber(2)+1;
        int foods = Greenfoot.getRandomNumber(4)*2+anthills+2;

        for(int i=0; i <= anthills; i++)
        {
            addObject(new Anthill(), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));
        }
        for(int j=0; j <= foods; j++)
        {
            addObject(new HoneyDrop(Greenfoot.getRandomNumber(20)*3+20), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));
        }
        addObject(new Feeder(), 0, 0);
        addObject(new Predator(), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));

    }
    public void game(){
        //Scenario with a Player actor. It's possible to play a little.
        removeObjects(getObjects(null)); // Removes all objects
        int anthills = Greenfoot.getRandomNumber(2)+1;
        int foods = Greenfoot.getRandomNumber(4)*2+anthills+2;

        for(int i=0; i <= anthills; i++)
        {
            addObject(new Anthill(), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));
        }
        for(int j=0; j <= foods; j++)
        {
            addObject(new HoneyDrop(Greenfoot.getRandomNumber(20)*3+20), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));
        }
        addObject(new Feeder(), 0, 0);
        addObject(new Player(), 10+Greenfoot.getRandomNumber(getWidth()-20), 10+Greenfoot.getRandomNumber(getHeight()-20));

    }

}
